//--- Copyright  2008, Stellar Software
//--- 19.10.08
#include "stdafx.h"

#include <stdio.h>
#include <stddef.h>
#include "rtwtypes.h"
#include <windows.h>

typedef struct {
	int32_T Input;
} ExternalInputs_rtwdemo_shrlib;

typedef struct {
	int32_T Output;
} ExternalOutputs_rtwdemo_shrlib;

HINSTANCE handleLib;
void (*mdl_initialize)(boolean_T);
void (*mdl_step)(void);
void (*mdl_terminate)(void);
ExternalInputs_rtwdemo_shrlib (*mdl_Uptr);
ExternalOutputs_rtwdemo_shrlib (*mdl_Yptr);

bool initState=false;

bool InitData(void)
{
	handleLib = LoadLibrary(L"proba_pera_win32.dll");
	if (!handleLib) return(false);

	mdl_initialize =(void(*)(boolean_T))GetProcAddress(handleLib , "_proba_pera_initialize");
	mdl_step       =(void(*)(void))GetProcAddress(handleLib , "_proba_pera_step");
	mdl_terminate  =(void(*)(void))GetProcAddress(handleLib , "_proba_pera_terminate");
	mdl_Uptr       =(ExternalInputs_rtwdemo_shrlib*)GetProcAddress(handleLib , "_proba_pera_U");
	mdl_Yptr       =(ExternalOutputs_rtwdemo_shrlib*)GetProcAddress(handleLib , "_proba_pera_Y");

	if (mdl_initialize && mdl_step && mdl_terminate && mdl_Uptr && mdl_Yptr) initState=true;
	else return(false);

	mdl_initialize(1);

	return(initState);
}
BOOL APIENTRY DllMain( HMODULE hModule,
					  DWORD  ul_reason_for_call,
					  LPVOID lpReserved
					  )
{
	switch(ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		{
			if(InitData()<0) return(FALSE);
			break;
		}
	case DLL_PROCESS_DETACH:
		if(initState)
		{
			mdl_terminate();
			FreeLibrary(handleLib);
		}
		break;
	}
	return TRUE;
}

//----------------------------
// 	/
//-------------------------

__declspec(dllexport) int __stdcall MT_Query(double* inputData, int inputSize, double* outputData, int outputSize)

{
	if(!initState) return(-2);

	mdl_Uptr->Input = inputData[0];
	mdl_step(); 
	outputData[0]=mdl_Yptr->Output; 

	return 1;
}